-------------------------------------------------------------------------------------
--  File Name   : clk_check_process.vhd
--  Function    : NbN݊ĎH̉p
--  Author      : F.O (ProXi)
-- ylz     : {\[X ASIANL@ (Attributed SIgnAl Naming)  ŋLqĂB
--              :   ڍׂ http://www.proxi.co.jp/technolo/asian.pdf Q
-------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------
--  NbN݊Ď    iNbNĎH̉pj
--      {̓NbN0 (20MHz, 50nSec)̒~ƃNbN1 (9.8304MHz, 101.725nSec) 
--      ̒~𑊌݂ɊĎ̂ƂB
-------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity clk_check_process is
    port (
      -- in
        a_rst           : in  std_logic;    -- VXeZbgi񓯊j
        clk0            : in  std_logic;    -- NbN0   20MHz, 50nSec
        clk1            : in  std_logic;    -- NbN1   9.8304MHz, 101.725nSec
      -- out
        a_clk_down0     : out std_logic;    --  NbN0~z[ho
        ah_clk_down0    : out std_logic;    --  NbN0~z[ho
        a_clk_down1     : out std_logic;    --  NbN1~z[ho
        ah_clk_down1    : out std_logic     --  NbN1~z[ho
    );
end;

architecture rtl of clk_check_process is
begin
    -- NbN0 Ď
    clock_monitor0 : entity work.clock_monitor
        generic map (WIDTH => 5)                    -- ~Ď 16 clock x 101.725nSec/clock = 1.6276 usec 
        port map (
          -- in
            a_rst               => a_rst,           -- Zbǵi񓯊j
            base_clk            => clk1,            -- Ďpx[XNbN
            a_monitored_clk     => clk0,            -- ĎNbNi񓯊j
          -- out
            a_clk_down_status   => a_clk_down0,     -- NbN0~z[ho
            ah_clk_down         => ah_clk_down0     -- NbN0~z[ho
        );

    -- NbN1 Ď
    clock_monitor1 : entity work.clock_monitor
        generic map (WIDTH => 6)                    -- ~Ď 32 clock x 50nSec/clock = 1.6 usec 
        port map (
          -- in
            a_rst               => a_rst,           -- Zbǵi񓯊j
            base_clk            => clk0,            -- Ďpx[XNbN
            a_monitored_clk     => clk1,            -- ĎNbNi񓯊j
          -- out
            a_clk_down_status   => a_clk_down1,     -- NbN0~z[ho
            ah_clk_down         => ah_clk_down1     -- NbN0~z[ho
        );

end rtl;

